Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/InfillSolver.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/InfillSolver.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/InfillSolver.cs	(revision 15064)
@@ -0,0 +1,107 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Algorithms.EGO {
+  /// <summary>
+  /// A base class for operators that manipulate real-valued vectors.
+  /// </summary>
+  [Item("InfillSolver", "A RealVectorCreator that creates candidates by optimizing an infill-subproblem")]
+  [StorableClass]
+  public class InfillSolver : RealVectorCreator {
+
+    public ILookupParameter<IAlgorithm> InfillOptimizationAlgorithmParamter => (ILookupParameter<IAlgorithm>)Parameters["InfillAlgorithm"];
+    public ILookupParameter<IRegressionSolution> ModelParameter => (ILookupParameter<IRegressionSolution>)Parameters["Model"];
+    public ILookupParameter<BoolValue> MaximizationParameter => (ILookupParameter<BoolValue>)Parameters["Maximization"];
+    public ILookupParameter<BoolValue> RemoveDuplicatesParameter => (ILookupParameter<BoolValue>)Parameters["RemoveDuplicates"];
+    public IFixedValueParameter<DoubleValue> DuplicateCutoffParameter => (IFixedValueParameter<DoubleValue>)Parameters["Duplicates Cutoff"];
+    public ILookupParameter<DoubleMatrix> InfillBoundsParameter => (ILookupParameter<DoubleMatrix>)Parameters["InfillBounds"];
+
+    [StorableConstructor]
+    protected InfillSolver(bool deserializing) : base(deserializing) { }
+    protected InfillSolver(InfillSolver original, Cloner cloner) : base(original, cloner) { }
+    public InfillSolver() {
+      Parameters.Add(new LookupParameter<IAlgorithm>("InfillAlgorithm", "The algorithm used to optimize the infill problem") { Hidden = true });
+      Parameters.Add(new LookupParameter<IRegressionSolution>("Model", "The RegressionSolution upon which the InfillProblem operates") { Hidden = true });
+      Parameters.Add(new LookupParameter<BoolValue>("Maximization", "Whether the original problem is a maximization problem") { Hidden = true });
+      Parameters.Add(new LookupParameter<BoolValue>("RemoveDuplicates", "Whether duplicates shall be removed") { Hidden = true });
+      Parameters.Add(new FixedValueParameter<DoubleValue>("Duplicates Cutoff", "The cut off radius for", new DoubleValue(0.01)) { Hidden = false });
+      Parameters.Add(new LookupParameter<DoubleMatrix>("InfillBounds", "The bounds applied for infill solving") { Hidden = true });
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new InfillSolver(this, cloner);
+    }
+
+    protected override RealVector Create(IRandom random, IntValue length, DoubleMatrix bounds) {
+      var infillBounds = InfillBoundsParameter.ActualValue;
+      if (infillBounds != null && infillBounds.Rows > 0) {
+        bounds = infillBounds;
+      }
+
+      var alg = InfillOptimizationAlgorithmParamter.ActualValue;
+      var model = ModelParameter.ActualValue;
+      var max = MaximizationParameter.ActualValue.Value;
+      var res = OptimizeInfillProblem(alg, model, max, bounds, length.Value, random);
+      var rad = DuplicateCutoffParameter.Value.Value;
+      if (!RemoveDuplicatesParameter.ActualValue.Value || !(GetMinDifference(model.ProblemData.Dataset, res) < rad * rad)) return res;
+      for (var i = 0; i < res.Length; i++) res[i] += random.NextDouble() * rad * 2;
+      return res;
+    }
+
+    public static RealVector OptimizeInfillProblem(IAlgorithm algorithm, IRegressionSolution model, bool maximization, DoubleMatrix bounds, int length, IRandom random) {
+      var infillProblem = algorithm.Problem as InfillProblem;
+      if (infillProblem == null) throw new ArgumentException("The algortihm has no InfillProblem to solve");
+      infillProblem.Encoding.Length = length;
+      infillProblem.Encoding.Bounds = bounds;
+      infillProblem.Initialize(model, maximization);
+      var res = EgoUtilities.SyncRunSubAlgorithm(algorithm, random.Next(int.MaxValue));
+      var v = res[InfillProblem.BestInfillSolutionResultName].Value as RealVector;
+      algorithm.Runs.Clear();
+      return v;
+    }
+
+    private static double GetMinDifference(IDataset data, RealVector r) {
+      var mind = double.MaxValue;
+      for (var i = 0; i < data.Rows; i++) {
+        var d = 0.0;
+        for (var j = 0; j < r.Length; j++) {
+          var d2 = data.GetDoubleValue("input" + j, i) - r[j];
+          d += d2 * d2;
+        }
+        if (!(d < mind)) continue;
+        mind = d;
+      }
+      return mind;
+    }
+
+
+  }
+}
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/ModelBuilder.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/ModelBuilder.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/ModelBuilder.cs	(revision 15064)
@@ -0,0 +1,137 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Algorithms.DataAnalysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Algorithms.EGO {
+  /// <summary>
+  /// A base class for operators that manipulate real-valued vectors.
+  /// </summary>
+  [Item("ModelBuilder", "Builds a model from a dataset and a given RegressionAlgorithm")]
+  [StorableClass]
+  public class ModelBuilder : InstrumentedOperator, IStochasticOperator {
+    public override bool CanChangeName => true;
+
+    public ILookupParameter<IDataAnalysisAlgorithm<IRegressionProblem>> RegressionAlgorithmParameter => (ILookupParameter<IDataAnalysisAlgorithm<IRegressionProblem>>)Parameters["RegressionAlgorithm"];
+    public ILookupParameter<IRegressionSolution> ModelParameter => (ILookupParameter<IRegressionSolution>)Parameters["Model"];
+    public ILookupParameter<ModifiableDataset> DatasetParameter => (ILookupParameter<ModifiableDataset>)Parameters["Dataset"];
+    public ILookupParameter<IRandom> RandomParameter => (ILookupParameter<IRandom>)Parameters["Random"];
+    public ILookupParameter<IntValue> MaxModelSizeParameter => (ILookupParameter<IntValue>)Parameters["Maximal Model Size"];
+    public ILookupParameter<DoubleMatrix> InfillBoundsParameter => (ILookupParameter<DoubleMatrix>)Parameters["InfillBounds"];
+
+    [StorableConstructor]
+    protected ModelBuilder(bool deserializing) : base(deserializing) { }
+    protected ModelBuilder(ModelBuilder original, Cloner cloner) : base(original, cloner) { }
+    public ModelBuilder() {
+      Parameters.Add(new LookupParameter<IDataAnalysisAlgorithm<IRegressionProblem>>("RegressionAlgorithm", "The algorithm used to build a model") { Hidden = true });
+      Parameters.Add(new LookupParameter<IRegressionSolution>("Model", "The resulting model") { Hidden = true });
+      Parameters.Add(new LookupParameter<ModifiableDataset>("Dataset", "The Dataset from which the model is created") { Hidden = true });
+      Parameters.Add(new LookupParameter<IRandom>("Random", "A random number generator") { Hidden = true });
+      Parameters.Add(new LookupParameter<IntValue>("Maximal Model Size", "The maximum number of sample points used to build the model (Set -1 for infinite size") { Hidden = true });
+      Parameters.Add(new LookupParameter<DoubleMatrix>("InfillBounds", "The bounds applied for infill solving") { Hidden = true });
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ModelBuilder(this, cloner);
+    }
+
+    public override IOperation InstrumentedApply() {
+      var regressionAlg = RegressionAlgorithmParameter.ActualValue;
+      IDataset data = DatasetParameter.ActualValue;
+      var random = RandomParameter.ActualValue;
+      var oldModel = ModelParameter.ActualValue;
+      var max = MaxModelSizeParameter.ActualValue.Value;
+      if (data.Rows > max && max > 0) {
+        data = SelectBestSamples(data, max);
+        InfillBoundsParameter.ActualValue = GetBounds(data);
+      }
+      ModelParameter.ActualValue = BuildModel(random, regressionAlg, data, oldModel);
+      return base.InstrumentedApply();
+    }
+
+    private DoubleMatrix GetBounds(IDataset data) {
+      var res = new DoubleMatrix(data.Columns - 1, 2);
+      var names = data.DoubleVariables.ToArray();
+      for (var i = 0; i < names.Length - 1; i++) {
+        res[i, 0] = data.GetDoubleValues(names[i]).Min();
+        res[i, 1] = data.GetDoubleValues(names[i]).Max();
+      }
+      return res;
+    }
+
+    private static Dataset SelectBestSamples(IDataset data, int max) {
+      var bestSampleIndices = data.GetDoubleValues("output").Select((d, i) => Tuple.Create(d, i)).OrderBy(x => x.Item1).Take(max).Select(x => x.Item2).ToArray();
+      return new Dataset(data.VariableNames, data.VariableNames.Select(v => data.GetDoubleValues(v, bestSampleIndices).ToList()));
+    }
+
+    private static IRegressionSolution BuildModel(IRandom random, IDataAnalysisAlgorithm<IRegressionProblem> regressionAlgorithm, IDataset dataset, IRegressionSolution oldSolution) {
+      //var dataset = EgoUtilities.GetDataSet(dataSamples, RemoveDuplicates);
+      var problemdata = new RegressionProblemData(dataset, dataset.VariableNames.Where(x => !x.Equals("output")), "output");
+      problemdata.TrainingPartition.Start = 0;
+      problemdata.TrainingPartition.End = dataset.Rows;
+      problemdata.TestPartition.Start = dataset.Rows;
+      problemdata.TestPartition.End = dataset.Rows;
+
+      //train 
+      var problem = (RegressionProblem)regressionAlgorithm.Problem;
+      problem.ProblemDataParameter.Value = problemdata;
+      var i = 0;
+      IRegressionSolution solution = null;
+
+      while (solution == null && i++ < 100) {
+        var results = EgoUtilities.SyncRunSubAlgorithm(regressionAlgorithm, random.Next(int.MaxValue));
+        solution = results.Select(x => x.Value).OfType<IRegressionSolution>().SingleOrDefault();
+      }
+
+      //try creating a model with old hyperparameters and new dataset;
+      var gp = regressionAlgorithm as GaussianProcessRegression;
+      var oldmodel = oldSolution as GaussianProcessRegressionSolution;
+      if (gp != null && oldmodel != null) {
+        var mean = (IMeanFunction)oldmodel.Model.MeanFunction.Clone();
+        var cov = (ICovarianceFunction)oldmodel.Model.CovarianceFunction.Clone();
+        try {
+          var model = new GaussianProcessModel(problemdata.Dataset, problemdata.TargetVariable,
+            problemdata.AllowedInputVariables, problemdata.TrainingIndices, new[] { 0.0 }, mean, cov);
+          model.FixParameters();
+          var sol = new GaussianProcessRegressionSolution(model, problemdata);
+          if (solution == null || solution.TrainingMeanSquaredError > sol.TrainingMeanSquaredError) {
+            solution = sol;
+          }
+        }
+        catch (ArgumentException) { }
+      }
+
+      regressionAlgorithm.Runs.Clear();
+      return solution;
+
+    }
+  }
+}
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/ModelQualityAnalyzer.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/ModelQualityAnalyzer.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/ModelQualityAnalyzer.cs	(revision 15064)
@@ -0,0 +1,94 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Algorithms.EGO {
+  /// <summary>
+  /// A base class for operators that manipulate real-valued vectors.
+  /// </summary>
+  [Item("ModelQualityAnalyzer", "Collects RealVectors into a modifiablbe dataset")]
+  [StorableClass]
+  public class ModelQualityAnalyzer : SingleSuccessorOperator, IAnalyzer {
+    public override bool CanChangeName => true;
+    public bool EnabledByDefault => false;
+
+    public ILookupParameter<IRegressionSolution> ModelParameter => (ILookupParameter<IRegressionSolution>)Parameters["Model"];
+    public ILookupParameter<ResultCollection> ResultsParameter => (ILookupParameter<ResultCollection>)Parameters["Results"];
+
+    private const string PlotName = "Model Quality Values";
+    private const string R2RowName = "Training R²";
+    private const string MAERowName = "Training Mean Absolute Error";
+    private const string RMSERowName = "Training Root Mean Squared Error";
+    private const string ModelResultName = "Model";
+
+
+    [StorableConstructor]
+    protected ModelQualityAnalyzer(bool deserializing) : base(deserializing) { }
+    protected ModelQualityAnalyzer(ModelQualityAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public ModelQualityAnalyzer() {
+      Parameters.Add(new LookupParameter<IRegressionSolution>("Model", "The model of this iteration"));
+      Parameters.Add(new LookupParameter<ResultCollection>("Results", "The collection to store the results in."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ModelQualityAnalyzer(this, cloner);
+    }
+
+    public sealed override IOperation Apply() {
+      var model = ModelParameter.ActualValue;
+      var results = ResultsParameter.ActualValue;
+      if (model == null) return base.Apply();
+      var plot = CreateDataTableResult(results);
+      plot.Rows[R2RowName].Values.Add(model.TrainingRSquared);
+      plot.Rows[MAERowName].Values.Add(model.TrainingMeanAbsoluteError);
+      plot.Rows[RMSERowName].Values.Add(model.TrainingRootMeanSquaredError);
+      if (!results.ContainsKey(ModelResultName)) results.Add(new Result(ModelResultName, model));
+      results[ModelResultName].Value = model;
+      return base.Apply();
+    }
+
+    private static DataTable CreateDataTableResult(ResultCollection results) {
+      DataTable plot;
+      if (!results.ContainsKey(PlotName)) {
+        plot = new DataTable("Model-Quality-Measures", "The quality measures of the models on the training data") {
+          VisualProperties = {
+            XAxisTitle = "Generation",
+          }
+        };
+        results.Add(new Result(PlotName, plot));
+      } else plot = (DataTable)results[PlotName].Value;
+      if (!plot.Rows.ContainsKey(R2RowName)) plot.Rows.Add(new DataRow(R2RowName, R2RowName, new double[0]));
+      if (!plot.Rows.ContainsKey(MAERowName)) plot.Rows.Add(new DataRow(MAERowName, MAERowName, new double[0]));
+      if (!plot.Rows.ContainsKey(RMSERowName)) plot.Rows.Add(new DataRow(RMSERowName, RMSERowName, new double[0]));
+
+      return plot;
+    }
+
+  }
+}
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/SampleCollector.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/SampleCollector.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/SampleCollector.cs	(revision 15064)
@@ -0,0 +1,84 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Algorithms.EGO {
+  /// <summary>
+  /// A base class for operators that manipulate real-valued vectors.
+  /// </summary>
+  [Item("SampleCollector", "Collects RealVectors into a modifiablbe dataset")]
+  [StorableClass]
+  public class SampleCollector : InstrumentedOperator {
+    public override bool CanChangeName => true;
+
+    public ILookupParameter<RealVector> RealVectorParameter => (ILookupParameter<RealVector>)Parameters["RealVector"];
+    public ILookupParameter<DoubleValue> QualityParameter => (ILookupParameter<DoubleValue>)Parameters["Quality"];
+    public ILookupParameter<ModifiableDataset> DatasetParameter => (ILookupParameter<ModifiableDataset>)Parameters["Dataset"];
+
+    [StorableConstructor]
+    protected SampleCollector(bool deserializing) : base(deserializing) { }
+    protected SampleCollector(SampleCollector original, Cloner cloner) : base(original, cloner) { }
+    public SampleCollector() {
+      Parameters.Add(new LookupParameter<RealVector>("RealVector", "The vector which should be collected."));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality associated which this vector"));
+      Parameters.Add(new LookupParameter<ModifiableDataset>("Dataset", "The Dataset in wich new samples are stored."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SampleCollector(this, cloner);
+    }
+
+    public sealed override IOperation InstrumentedApply() {
+      var vector = RealVectorParameter.ActualValue;
+      var quality = QualityParameter.ActualValue.Value;
+      var data = DatasetParameter.ActualValue;
+
+      if (data.Columns != vector.Length + 1) {
+        if (data.Columns != 0 || data.Rows != 0) throw new OperatorExecutionException(this, "dataset columns do not match samplesize+1");
+        for (var i = 0; i < vector.Length; i++)
+          data.AddVariable("input" + i, new double[0]);
+        data.AddVariable("output", new double[0]);
+      }
+      AddRow(data, vector, quality);
+      return base.InstrumentedApply(); ;
+    }
+
+
+    private static void AddRow(ModifiableDataset data, RealVector vector, double quality) {
+      var row = new object[vector.Length + 1];
+      for (var i = 0; i < vector.Length; i++)
+        row[i] = vector[i];
+      row[vector.Length] = quality;
+      data.AddRow(row);
+    }
+
+
+
+  }
+}
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/VariableVariabilityAnalyzer.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/VariableVariabilityAnalyzer.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/VariableVariabilityAnalyzer.cs	(revision 15064)
@@ -0,0 +1,102 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Algorithms.EGO {
+  [Item("VariableVariabilityAnalyzer", "Analyzes the correlation between perdictions and actual fitness values")]
+  [StorableClass]
+  public class VariableVariabilityAnalyzer : SingleSuccessorOperator, IAnalyzer {
+    public override bool CanChangeName => true;
+    public bool EnabledByDefault => false;
+
+    public ILookupParameter<ModifiableDataset> DatasetParameter => (ILookupParameter<ModifiableDataset>)Parameters["Dataset"];
+    public ILookupParameter<ResultCollection> ResultsParameter => (ILookupParameter<ResultCollection>)Parameters["Results"];
+    public ILookupParameter<IntValue> InitialEvaluationsParameter => (ILookupParameter<IntValue>)Parameters["Initial Evaluations"];
+    public IFixedValueParameter<IntValue> LookBackSizeParameter => (IFixedValueParameter<IntValue>)Parameters["LookBackSize"];
+
+    private const string NormalizedPlotName = "Normalized Variable Variance";
+    private const string PlotName = "Variable Variance";
+
+    [StorableConstructor]
+    protected VariableVariabilityAnalyzer(bool deserializing) : base(deserializing) { }
+    protected VariableVariabilityAnalyzer(VariableVariabilityAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public VariableVariabilityAnalyzer() {
+      Parameters.Add(new FixedValueParameter<IntValue>("LookBackSize", new IntValue(10)));
+      Parameters.Add(new LookupParameter<IntValue>("Initial Evaluations"));
+      Parameters.Add(new LookupParameter<ModifiableDataset>("Dataset"));
+      Parameters.Add(new LookupParameter<ResultCollection>("Results", "The collection to store the results in."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVariabilityAnalyzer(this, cloner);
+    }
+
+    public sealed override IOperation Apply() {
+      var dataset = DatasetParameter.ActualValue;
+      var results = ResultsParameter.ActualValue;
+      var initialEvals = InitialEvaluationsParameter.ActualValue.Value;
+      var lbsize = LookBackSizeParameter.Value.Value;
+
+      var normPlot = CreateScatterPlotResult(results, NormalizedPlotName);
+      var plot = CreateScatterPlotResult(results, PlotName);
+      foreach (var s in dataset.VariableNames) {
+        if (!normPlot.Rows.ContainsKey(s)) normPlot.Rows.Add(new DataRow(s));
+        if (!plot.Rows.ContainsKey(s)) plot.Rows.Add(new DataRow(s));
+
+        if (dataset.Rows < lbsize) continue;
+        var wd = dataset.GetDoubleValues(s, Enumerable.Range(dataset.Rows - lbsize, lbsize)).StandardDeviation();
+        plot.Rows[s].Values.Add(wd);
+
+        if (dataset.Rows < Math.Max(initialEvals, lbsize)) continue;
+        var sd = dataset.GetDoubleValues(s, Enumerable.Range(0, initialEvals)).StandardDeviation();
+        normPlot.Rows[s].Values.Add(wd / sd);
+      }
+      return base.Apply();
+    }
+
+    private static DataTable CreateScatterPlotResult(ResultCollection results, string plotname) {
+      DataTable plot;
+      if (!results.ContainsKey(plotname)) {
+        plot = new DataTable(plotname) {
+          VisualProperties = {
+            XAxisTitle = "Iteration",
+            YAxisTitle = plotname.Equals(NormalizedPlotName)? "Normalized Variance (Variance of last Samples)/(Variance of Initial Samples)" : "Standard deviation of last samples"
+          }
+        };
+        results.Add(new Result(plotname, plot));
+      }
+      plot = (DataTable)results[plotname].Value;
+      return plot;
+    }
+
+  }
+}
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Plugin.cs.frame
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Plugin.cs.frame	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Plugin.cs.frame	(revision 15064)
@@ -28,5 +28,4 @@
   [Plugin("HeuristicLab.Algorithms.EGO", "3.4.5.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.EGO-3.4.dll", PluginFileType.Assembly)]
-  [PluginFile("displayModelFrame.html", PluginFileType.Data)]
   [PluginDependency("HeuristicLab.Algorithms.CMAEvolutionStrategy", "3.4")]
   [PluginDependency("HeuristicLab.Algorithms.DataAnalysis", "3.4")]
@@ -34,10 +33,11 @@
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.Encodings.RealVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.PermutationEncoding", "3.3")]
   [PluginDependency("HeuristicLab.Operators","3.3")]
   [PluginDependency("HeuristicLab.Optimization","3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Operators","3.3")]
   [PluginDependency("HeuristicLab.Parameters","3.3")]
   [PluginDependency("HeuristicLab.Persistence","3.3")]
